# frozen_string_literal: true

require('thor')
require('etht/bigquery')
require('etht/carteiras')
require('etht/etherscan')
require('etht/formatar')
require('etht/version')

# @author Hernani Rodrigues Vaz
module Etht
  # classe para erros desta gem
  class Erro < StandardError
    # @return [StandardError] personalizacao dos erros
    def initialize(msg)
      super(msg)
    end
  end

  # classe para carregar/mostrar dados comuns bigquery & etherscan
  class CLI < Thor
    desc 'work', 'carrega transacoes novas no bigquery'
    option :h, type: :hash, default: {}, desc: 'configuracao ajuste reposicionamento temporal'
    # carrega transacoes novas no bigquery
    def work
      Bigquery.new(options).processa
    end

    desc 'show', 'mostra reumo carteiras & transacoes'
    option :v, type: :boolean, default: false, desc: 'mostra transacoes normais & token'
    option :t, type: :boolean, default: false, desc: 'mostra transacoes todas ou somente novas'
    # mostra reumo carteiras & transacoes
    def show
      Bigquery.new(options).carteiras.mostra_resumo
    end

    default_task :show
  end
end
